/*
  backgrid
  http://github.com/wyuenho/backgrid

  Copyright (c) 2013 Jimmy Yuen Ho Wong
  Licensed under the MIT @license.
*/
(function(e,t,i,n){"use strict";function r(e){return String.prototype.trim?String.prototype.trim.call(e,e):e.replace(/^\s+|\s+$/g,"")}function o(e){return String.fromCharCode(e.charCodeAt(0)-32)+e.slice(1)}function l(e,t,i){var n=t-(e+"").length;n=0>n?0:n;for(var r="",o=0;n>o;o++)r+=i;return r+e}function s(e,t){for(var n=0;t.length>n;n++){var r=t[n];if(i.isUndefined(e[r]))throw new TypeError("'"+r+"' is required")}}function a(e,t){if(i.isString(e)){var n=o(e)+t,r=d[n]||d.Extension[n];if(i.isUndefined(r))throw new ReferenceError("Class '"+n+"' not found");return r}return e}var c=e,d=e.Backgrid={VERSION:"0.1.1",Extension:{}},u=d.CellFormatter=function(){};i.extend(u.prototype,{fromRaw:function(e){return e},toRaw:function(e){return e}});var h=d.NumberFormatter=function(e){if(e=e?i.clone(e):{},i.extend(this,this.defaults,e),0>this.decimals||this.decimals>20)throw new RangeError("decimals must be between 0 and 20")};h.prototype=new u,i.extend(h.prototype,{defaults:{decimals:2,decimalSeparator:".",orderSeparator:","},HUMANIZED_NUM_RE:/(\d)(?=(?:\d{3})+$)/g,fromRaw:function(e){if(isNaN(e)||null===e)return"";e=e.toFixed(~~this.decimals);var t=e.split("."),i=t[0],n=t[1]?(this.decimalSeparator||".")+t[1]:"";return i.replace(this.HUMANIZED_NUM_RE,"$1"+this.orderSeparator)+n},toRaw:function(e){for(var t="",n=r(e).split(this.orderSeparator),o=0;n.length>o;o++)t+=n[o];var l=t.split(this.decimalSeparator);t="";for(var o=0;l.length>o;o++)t=t+l[o]+".";"."===t[t.length-1]&&(t=t.slice(0,t.length-1));var s=1*(1*t).toFixed(~~this.decimals);return i.isNumber(s)&&!i.isNaN(s)?s:void 0}});var m=d.DatetimeFormatter=function(e){if(e=e?i.clone(e):{},i.extend(this,this.defaults,e),!this.includeDate&&!this.includeTime)throw Error("Either includeDate or includeTime must be true")};m.prototype=new u,i.extend(m.prototype,{defaults:{includeDate:!0,includeTime:!0,includeMilli:!1},DATE_RE:/^([+\-]?\d{4})-(\d{2})-(\d{2})$/,TIME_RE:/^(\d{2}):(\d{2}):(\d{2})(\.(\d{3}))?$/,ISO_SPLITTER_RE:/T|Z| +/,_convert:function(e,t){e=r(e);var n=e.split(this.ISO_SPLITTER_RE)||[],o=this.DATE_RE.test(n[0])?n[0]:"",s=o&&n[1]?n[1]:this.TIME_RE.test(n[0])?n[0]:"",a=this.DATE_RE.exec(o)||[],c=this.TIME_RE.exec(s)||[];if(t){if(this.includeDate&&i.isUndefined(a[0]))return;if(this.includeTime&&i.isUndefined(c[0]))return;if(!this.includeDate&&o)return;if(!this.includeTime&&s)return}var d=new Date(Date.UTC(1*a[1]||0,1*a[2]-1||0,1*a[3]||0,1*c[1]||null,1*c[2]||null,1*c[3]||null,1*c[5]||null)),u="";return this.includeDate&&(u=l(d.getUTCFullYear(),4,0)+"-"+l(d.getUTCMonth()+1,2,0)+"-"+l(d.getUTCDate(),2,0)),this.includeTime&&(u=u+(this.includeDate?"T":"")+l(d.getUTCHours(),2,0)+":"+l(d.getUTCMinutes(),2,0)+":"+l(d.getUTCSeconds(),2,0),this.includeMilli&&(u=u+"."+l(d.getUTCMilliseconds(),3,0))),this.includeDate&&this.includeTime&&(u+="Z"),u},fromRaw:function(e){return this._convert(e)},toRaw:function(e){return this._convert(e,!0)}});var f=d.CellEditor=n.View.extend({initialize:function(e){s(e,["formatter","column","model"]),this.parent=e.parent,this.formatter=e.formatter,this.column=e.column,this.column instanceof y||(this.column=new y(this.column)),this.parent&&i.isFunction(this.parent.on)&&this.listenTo(this.parent,"editing",this.postRender)},postRender:function(){return this.$el.focus(),this}}),p=d.InputCellEditor=f.extend({tagName:"input",attributes:{type:"text"},events:{blur:"saveOrCancel",keydown:"saveOrCancel"},initialize:function(e){f.prototype.initialize.apply(this,arguments),e.placeholder&&this.$el.attr("placeholder",e.placeholder),this.listenTo(this,"done",this.remove)},render:function(){return this.$el.val(this.formatter.fromRaw(this.model.get(this.column.get("name")))),this},saveOrCancel:function(e){if("keydown"===e.type)if(13===e.keyCode||9===e.keyCode){e.preventDefault();var t=this.formatter.toRaw(this.$el.val());i.isUndefined(t)||!this.model.set(this.column.get("name"),t,{validate:!0})?this.trigger("error"):this.trigger("done")}else 27===e.keyCode&&(e.stopPropagation(),this.trigger("done"));else if("blur"===e.type)if(this.formatter.fromRaw(this.model.get(this.column.get("name")))===this.$el.val())this.trigger("done");else var n=this,r=c.setTimeout(function(){n.$el.focus(),c.clearTimeout(r)},1)},postRender:function(){if("right"===this.$el.css("text-align")){var e=this.$el.val();this.$el.focus().val(null).val(e)}else this.$el.focus();return this}}),v=d.Cell=n.View.extend({tagName:"td",formatter:new u,editor:p,events:{click:"enterEditMode"},initialize:function(e){s(e,["model","column"]),this.column=e.column,this.column instanceof y||(this.column=new y(this.column)),this.formatter=a(this.formatter,"Formatter"),this.editor=a(this.editor,"CellEditor")},render:function(){return this.$el.empty().text(this.formatter.fromRaw(this.model.get(this.column.get("name")))),this},enterEditMode:function(){this.column.get("editable")&&(this.currentEditor=new this.editor({parent:this,column:this.column,model:this.model,formatter:this.formatter}),this.trigger("edit",this,this.currentEditor),this.listenTo(this.currentEditor,"done",this.exitEditMode),this.listenTo(this.currentEditor,"error",this.renderError),this.$el.empty(),this.undelegateEvents(),this.$el.append(this.currentEditor.$el),this.currentEditor.render(),this.$el.addClass("editor"),this.trigger("editing",this,this.currentEditor))},renderError:function(){this.$el.addClass("error")},exitEditMode:function(){this.$el.removeClass("error"),this.currentEditor.off(null,null,this),this.currentEditor.remove(),delete this.currentEditor,this.$el.removeClass("editor"),this.render(),this.delegateEvents()},remove:function(){n.View.prototype.remove.apply(this,arguments),this.currentEditor&&(this.currentEditor.remove(),delete this.currentEditor)}});d.StringCell=v.extend({className:"string-cell"}),d.UriCell=v.extend({className:"uri-cell",formatter:{fromRaw:function(e){return e},toRaw:function(e){var t=encodeURI(e);return"undefined"===t?void 0:t}},render:function(){this.$el.empty();var e=this.formatter.fromRaw(this.model.get(this.column.get("name")));return this.$el.append(t("<a>",{href:e,title:e,target:"_blank"}).text(e)),this}}),d.EmailCell=v.extend({className:"email-cell",formatter:{fromRaw:function(e){return e},toRaw:function(e){var t=e.split("@");return 2===t.length&&i.all(t)?e:void 0}},render:function(){this.$el.empty();var e=this.formatter.fromRaw(this.model.get(this.column.get("name")));return this.$el.append(t("<a>",{href:"mailto:"+e,title:e}).text(e)),this}});var g=d.NumberCell=v.extend({className:"number-cell",decimals:h.prototype.defaults.decimals,decimalSeparator:h.prototype.defaults.decimalSeparator,orderSeparator:h.prototype.defaults.orderSeparator,formatter:h,initialize:function(){v.prototype.initialize.apply(this,arguments),this.formatter=new this.formatter({decimals:this.decimals,decimalSeparator:this.decimalSeparator,orderSeparator:this.orderSeparator})}});d.IntegerCell=g.extend({className:"integer-cell",decimals:0});var w=d.DatetimeCell=v.extend({className:"datetime-cell",includeDate:m.prototype.defaults.includeDate,includeTime:m.prototype.defaults.includeTime,includeMilli:m.prototype.defaults.includeMilli,formatter:m,initialize:function(){v.prototype.initialize.apply(this,arguments),this.formatter=new this.formatter({includeDate:this.includeDate,includeTime:this.includeTime,includeMilli:this.includeMilli});var e=this.includeDate?"YYYY-MM-DD":"";e+=this.includeDate&&this.includeTime?"T":"",e+=this.includeTime?"HH:mm:ss":"",e+=this.includeTime&&this.includeMilli?".SSS":"",this.editor=this.editor.extend({attributes:i.extend({},this.editor.prototype.attributes,this.editor.attributes,{placeholder:e})})}});d.DateCell=w.extend({className:"date-cell",includeTime:!1}),d.TimeCell=w.extend({className:"time-cell",includeDate:!1}),d.BooleanCell=v.extend({className:"boolean-cell",editor:i.template("<input type='checkbox'<%= checked ? checked='checked' : '' %> />'"),events:{click:"enterEditMode","blur input[type=checkbox]":"exitEditMode","change input[type=checkbox]":"save"},render:function(){return this.$el.empty(),this.currentEditor=t(this.editor({checked:this.formatter.fromRaw(this.model.get(this.column.get("name")))})),this.$el.append(this.currentEditor),this},enterEditMode:function(){this.$el.addClass("editor"),this.currentEditor.focus()},exitEditMode:function(){this.$el.removeClass("editor")},save:function(){var e=this.formatter.toRaw(this.currentEditor.prop("checked"));this.model.set(this.column.get("name"),e)}});var C=d.SelectCellEditor=f.extend({tagName:"select",events:{change:"save",blur:"save"},template:i.template('<option value="<%= value %>" <%= selected ? \'selected="selected"\' : "" %>><%= text %></option>'),setOptionValues:function(e){this.optionValues=e},_renderOptions:function(e,t){for(var i="",n=0;e.length>n;n++)i+=this.template({text:e[n][0],value:e[n][1],selected:t==e[n][1]});return i},render:function(){this.$el.empty();var e=i.result(this,"optionValues"),n=this.model.get(this.column.get("name"));if(!i.isArray(e))throw TypeError("optionValues must be an array");for(var r=null,o=null,r=null,l=null,s=null,a=0;e.length>a;a++){var r=e[a];if(i.isArray(r))o=r[0],r=r[1],this.$el.append(this.template({text:o,value:r,selected:r==n}));else{if(!i.isObject(r))throw TypeError("optionValues elements must be a name-value pair or an object hash of { name: 'optgroup label', value: [option name-value pairs] }");l=r.name,s=t("<optgroup></optgroup>",{label:l}),s.append(this._renderOptions(r.values,n)),this.$el.append(s)}}return this},save:function(){this.model.set(this.column.get("name"),this.formatter.toRaw(this.$el.val())),this.trigger("done")}});d.SelectCell=v.extend({className:"select-cell",editor:C,optionValues:void 0,initialize:function(){v.prototype.initialize.apply(this,arguments),s(this,["optionValues"]),this.optionValues=i.result(this,"optionValues"),this.listenTo(this,"edit",this.setOptionValues)},setOptionValues:function(e,t){t.setOptionValues(this.optionValues)},render:function(){this.$el.empty();var e=this.optionValues,t=this.formatter.fromRaw(this.model.get(this.column.get("name")));try{if(!i.isArray(e)||i.isEmpty(e))throw new TypeError;for(var n=0;e.length>n;n++){var r=e[n];if(i.isArray(r)){var o=r[0],r=r[1];if(r==t){this.$el.append(o);break}}else{if(!i.isObject(r))throw new TypeError;for(var l=r.values,s=0;l.length>s;s++){var a=l[s];if(a[1]==t){this.$el.append(a[0]);break}}}}}catch(c){if(c instanceof TypeError)throw TypeError("'optionValues' must be of type {Array.<Array>|Array.<{name: string, values: Array.<Array>}>}");throw c}return this}});var y=d.Column=n.Model.extend({defaults:{name:void 0,label:void 0,sortable:!0,editable:!0,renderable:!0,formatter:void 0,cell:void 0,headerCell:void 0},initialize:function(e){s(e,["cell","name"]),this.has("label")||this.set({label:this.get("name")},{silent:!0});var t=a(this.get("cell"),"Cell");this.set({cell:t},{silent:!0})}}),E=d.Columns=n.Collection.extend({model:y}),$=d.Row=n.View.extend({tagName:"tr",initialize:function(e){var t=this;s(e,["columns","model"]);var r=t.columns=e.columns;r instanceof n.Collection||(r=t.columns=new E(r)),t.listenTo(r,"change:renderable",t.renderColumn);for(var o=t.cells=[],l=0;r.length>l;l++){var a=r.at(l);o.push(new(a.get("cell"))({column:a,model:t.model}))}t.listenTo(r,"add",function(e,n,r){r=i.defaults(r||{},{render:!0});var l=n.indexOf(e),s=new(e.get("cell"))({column:e,model:t.model});o.splice(l,0,s),t.renderColumn(e,e.get("renderable")&&r.render)}),t.listenTo(r,"remove",function(e){t.renderColumn(e,!1)})},renderColumn:function(e,t){for(var i=this,n=i.cells,r=i.columns,o=-1,l=0;n.length>l;l++){var s=n[l];if(s.column.get("name")==e.get("name")){o=l;break}}if(-1!=o){var a=i.$el;if(t){var s=n[o];0===o?a.prepend(s.render().$el):o===r.length-1?a.append(s.render().$el):a.children().eq(o).before(s.render().$el)}else a.children().eq(o).detach()}},render:function(){this.$el.empty();for(var e=0;this.cells.length>e;e++){var t=this.cells[e];t.column.get("renderable")&&this.$el.append(t.render().$el)}return this}}),b=d.HeaderCell=n.View.extend({tagName:"th",events:{"click a":"onClick"},_direction:null,initialize:function(e){s(e,["column","collection"]),this.column=e.column,this.column instanceof y||(this.column=new y(this.column)),this.listenTo(n,"backgrid:sort",this._resetCellDirection)},direction:function(e){return arguments.length&&(this._direction&&this.$el.removeClass(this._direction),e&&this.$el.addClass(e),this._direction=e),this._direction},_resetCellDirection:function(e,t,i,n){n==this.collection&&(e!==this.column.get("name")?this.direction(null):this.direction(t))},onClick:function(e){e.preventDefault();var t=this.column.get("name");this.column.get("sortable")&&("ascending"===this.direction()?this.sort(t,"descending",function(e,i){var n=e.get(t),r=i.get(t);return n===r?0:n>r?-1:1}):"descending"===this.direction()?this.sort(t,null):this.sort(t,"ascending",function(e,i){var n=e.get(t),r=i.get(t);return n===r?0:r>n?-1:1}))},sort:function(e,t,i){i=i||this._cidComparator;var r=this.collection;if(r instanceof n.PageableCollection){var o;o="ascending"===t?-1:"descending"===t?1:null,r.setSorting(o?e:null,o),"client"==r.mode?(r.fullCollection.comparator||(r.fullCollection.comparator=i),r.fullCollection.sort()):r.fetch()}else r.comparator=i,r.sort();n.trigger("backgrid:sort",e,t,i,this.collection)},_cidComparator:function(e,t){var n=e.cid,r=t.cid;if(!i.isUndefined(n)&&!i.isUndefined(r)){if(n=1*n.slice(1),r=1*r.slice(1),r>n)return-1;if(n>r)return 1}return 0},render:function(){this.$el.empty();var e=t("<a>").text(this.column.get("label")).append("<b class='sort-caret'></b>");return this.$el.append(e),this}});d.HeaderRow=d.Row.extend({initialize:function(e){var t=this;s(e,["columns","collection"]);var r=t.columns=e.columns;r instanceof n.Collection||(r=t.columns=new E(r)),t.listenTo(r,"change:renderable",t.renderColumn);for(var o=t.cells=[],l=0;r.length>l;l++){var a=r.at(l),c=a.get("headerCell")||e.headerCell||b;o.push(new c({column:a,collection:t.collection}))}t.listenTo(r,"add",function(n,r,l){l=i.defaults(l||{},{render:!0});var s=r.indexOf(n),a=n.get("headerCell")||e.headerCell||b;a=new a({column:n,collection:t.collection}),o.splice(s,0,a),t.renderColumn(n,n.get("renderable")&&l.render)}),t.listenTo(r,"remove",function(e){t.renderColumn(e,!1)})}});var T=d.Header=n.View.extend({tagName:"thead",initialize:function(e){s(e,["columns","collection"]),this.columns=e.columns,this.columns instanceof n.Collection||(this.columns=new E(this.columns)),this.row=new d.HeaderRow({columns:this.columns,collection:this.collection})},render:function(){return this.$el.append(this.row.render().$el),this}}),x=d.Body=n.View.extend({tagName:"tbody",initialize:function(e){s(e,["columns","collection"]);var t=this;t.columns=e.columns,t.columns instanceof n.Collection||(t.columns=new E(t.columns)),t.row=e.row||$,t.rows=t.collection.map(function(e){var i=new t.row({columns:t.columns,model:e});return i}),t.listenTo(t.collection,"add",t.insertRow),t.listenTo(t.collection,"remove",t.removeRow),t.listenTo(t.collection,"sort",t.refresh),t.listenTo(t.collection,"reset",t.refresh)},insertRow:function(e,t,r){if(!(t instanceof n.Collection||r))return this.collection.add(e,r=t),void 0;r=r||{};var o=new this.row({columns:this.columns,model:e}),l=t.indexOf(e);this.rows.splice(l,0,o),(i.isUndefined(r.render)||r.render)&&(l>=this.$el.children().length?this.$el.children().last().after(o.render().$el):this.$el.children().eq(l).before(o.render().$el))},removeRow:function(e,t,n){return n?((i.isUndefined(n.render)||n.render)&&this.rows[n.index].remove(),this.rows.splice(n.index,1),void 0):(this.collection.remove(e,n=t),void 0)},refresh:function(){var e=this;return i.each(e.rows,function(e){e.remove()}),e.rows=e.collection.map(function(t){var i=new e.row({columns:e.columns,model:t});return i}),e.render(),n.trigger("backgrid:refresh"),e},render:function(){var e=this;return e.$el.empty(),i.each(e.rows,function(t){e.$el.append(t.render().$el)}),this}});d.Footer=n.View.extend({tagName:"tfoot",initialize:function(e){s(e,["columns","collection"]),this.parent=e.parent,this.columns=e.columns,this.columns instanceof n.Collection||(this.columns=new d.Columns(this.columns))}}),d.Grid=n.View.extend({tagName:"table",className:"backgrid",header:T,body:x,footer:null,initialize:function(e){s(e,["columns","collection"]),this.columns=e.columns,this.columns instanceof n.Collection||(this.columns=new d.Columns(this.columns)),this.header=e.header||this.header,this.header=new this.header({columns:this.columns,collection:this.collection}),this.body=e.body||this.body,this.body=new this.body({columns:this.columns,collection:this.collection}),this.footer=e.footer||this.footer,this.footer&&(this.footer=new this.footer({columns:this.columns,collection:this.collection}))},insertRow:function(e,t,i){return this.body.insertRow(e,t,i)},removeRow:function(e,t,i){return this.body.removeRow(e,t,i)},insertColumn:function(e,t){var i=this;return t=t||{render:!0},i.columns.add(e,t),i},removeColumn:function(e,t){var i=this;return i.columns.remove(e,t),i},render:function(){return this.$el.empty(),this.$el.append(this.header.render().$el),this.footer&&this.$el.append(this.footer.render().$el),this.$el.append(this.body.render().$el),this.trigger("rendered"),this}})})(this,$,_,Backbone);